#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>

#include "applu.h"

erhs()
{
	double dsspm;
	double flux[isiz1][5], ue[isiz1][5];
	int i,j,k,m;
	double eta, zeta, xi, u21, q, tmp, u21i, u31i, u41i, u51i;
	double u21im1, u31im1, u41im1, u51im1;
	double u31, u21j, u31j, u41j, u51j, u21jm1, u31jm1, u41jm1, u51jm1;
	double u41, u21k, u31k, u41k, u51k, u21km1, u31km1, u41km1, u51km1;

	dsspm = dssp;
	for(k=0;k<nz;k++) {
		for(j=0;j<ny;j++) {
			for(i=0;i<nx;i++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] = 0.0;
				}
			}
		}
	}
	for(k=1;k<(nz-1);k++) {
		zeta = ((double)(k)/(nz-1));
		for(j=1;j<(ny-1);j++) {
			eta = ((double)(j)/(ny-1));
			for(i=0;i<nx;i++) {
				xi = ((double)(i)/(nx-1));
				for(m=0;m<5;m++) {
					ue[i][m] = ce[0][m]
						+ ce[1][m] * xi
						+ ce[2][m] * eta
						+ ce[3][m] * zeta
						+ ce[4][m] * xi * xi
						+ ce[5][m] * eta * eta
						+ ce[6][m] * zeta * zeta
						+ ce[7][m] * xi * xi * xi
						+ ce[8][m] * eta * eta * eta
						+ ce[9][m] * zeta * zeta * zeta
						+ ce[10][m] * xi * xi * xi * xi
						+ ce[11][m] * eta * eta * eta * eta
						+ ce[12][m] * zeta * zeta * zeta * zeta;
				}
				flux[i][0] = ue[i][1];
				u21 = ue[i][1]/ue[i][0];
				q = 0.5 * ( ue[i][1]*ue[i][1]
						  + ue[i][2]*ue[i][2]
						  + ue[i][3]*ue[i][3])/ue[i][0];
				flux[i][1] = ue[i][1] * u21 + c2 * (ue[i][4]-q);
				flux[i][2] = ue[i][2] * u21;
				flux[i][3] = ue[i][3] * u21;
				flux[i][4] = (c1*ue[i][4]-c2*q) * u21;
			}
			for(i=1;i<(nx-1);i++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -= (tx2*(flux[i+1][m]-flux[i-1][m]));
				}
			}
			for(i=1;i<nx;i++) {
				tmp = 1.0/ue[i][0];
				u21i = tmp*ue[i][1];
				u31i = tmp*ue[i][2];
				u41i = tmp*ue[i][3];
				u51i = tmp*ue[i][4];
				tmp = 1.0/ue[i-1][0];
				u21im1 = tmp*ue[i-1][1];
				u31im1 = tmp*ue[i-1][2];
				u41im1 = tmp*ue[i-1][3];
				u51im1 = tmp*ue[i-1][4];
				flux[i][1] = (4.0/3.0)*tx3*(u21i-u21im1);
				flux[i][2] = tx3*(u31i-u31im1);
				flux[i][3] = tx3*(u41i-u41im1);
				flux[i][4] = 0.5*(1.0-c1*c5)
					* tx3 * ((u21i*u21i + u31i*u31i +u41i*u41i)
						- (u21im1*u21im1+u31im1*u31im1+u41im1*u41im1))
					+ (1.0/6.0) * tx3 * (u21i*u21i - u21im1*u21im1)
					+ c1 * c5 * tx3 * (u51i - u51im1);
			}
			for(i=1;i<(nx-1);i++) {
				frct[k][j][i][0] += 
					(dx1*tx1*(ue[i-1][0]-2.0*ue[i][0]+ue[i+1][0]));
				frct[k][j][i][1] += 
					(tx3*c3*c4*(flux[i+1][1]-flux[i][1])
					+ dx2*tx1*(ue[i-1][1]-2.0*ue[i][1]+ue[i+1][1]));
				frct[k][j][i][2] +=
					(tx3*c3*c4*(flux[i+1][2]-flux[i][2])
					+ dx3*tx1*(ue[i-1][2]-2.0*ue[i][2]+ue[i+1][2]));
				frct[k][j][i][3] +=
					(tx3*c3*c4*(flux[i+1][3]-flux[i][3])
					+ dx4*tx1*(ue[i-1][3]-2.0*ue[i][3]+ue[i+1][3]));
				frct[k][j][i][4] +=
					(tx3*c3*c4*(flux[i+1][4]-flux[i][4])
					+ dx5*tx1*(ue[i-1][4]-2.0*ue[i][4]+ue[i+1][4]));
			}
			for(m=0;m<5;m++) {
				frct[k][j][1][m] -=
					(dsspm * (5.0*ue[1][m]-4.0*ue[2][m]+ue[3][m]));
				frct[k][j][2][m] -=
					(dsspm*(-4.0*ue[1][m]+6.0*ue[2][m]-4.0*ue[3][m]+ue[4][m]));
			}
			for(i=3;i<(nx-3);i++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -=
						(dsspm*(ue[i-2][m]-4.0*ue[i-1][m]+6.0*ue[i][m]
						-4.0*ue[i+1][m]+ue[i+2][m]));
				}
			}
			for(m=0;m<5;m++) {
				frct[k][j][nx-3][m] -=
					(dsspm*(ue[nx-5][m]-4.0*ue[nx-4][m]+6.0*ue[nx-3][m]-
					4.0*ue[nx-2][m]));
				frct[k][j][nx-2][m] -=
					(dsspm*(ue[nx-4][m]-4.0*ue[nx-3][m]+5.0*ue[nx-2][m]));
			}
		}
	}
	for(k=1;k<(nz-1);k++) {
		zeta = ((double)(k)/(nz-1));
		for(i=1;i<(nx-1);i++) {
			xi = ((double)(i)/(nx-1));
			for(j=0;j<ny;j++) {
				eta = ((double)(j)/(ny-1));
				for(m=0;m<5;m++) {
					ue[j][m] = ce[0][m]
						+ ce[1][m] * xi
						+ ce[2][m] * eta
						+ ce[3][m] * zeta
						+ ce[4][m] * xi * xi
						+ ce[5][m] * eta * eta
						+ ce[6][m] * zeta * zeta
						+ ce[7][m] * xi * xi * xi
						+ ce[8][m] * eta * eta * eta
						+ ce[9][m] * zeta * zeta * zeta
						+ ce[10][m] * xi * xi * xi * xi
						+ ce[11][m] * eta * eta * eta * eta
						+ ce[12][m] * zeta * zeta * zeta * zeta;
				}
				flux[j][0] = ue[j][2];
				u31 = ue[j][2]/ue[j][0];
				q = 0.5 * ( ue[j][1]*ue[j][1]
						  + ue[j][2]*ue[j][2]
						  + ue[j][3]*ue[j][3])/ue[j][0];
				flux[j][1] = ue[j][1] * u31;
				flux[j][2] = ue[j][2] * u31 + c2*(ue[j][4]-q);
				flux[j][3] = ue[j][3] * u31;
				flux[j][4] = (c1*ue[j][4]-c2*q) * u31;
			}
			for(j=1;j<(ny-1);j++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -= (ty2*(flux[j+1][m]-flux[j-1][m]));
				}
			}
			for(j=1;j<ny;j++) {
				tmp = 1.0/ue[j][0];
				u21j = tmp*ue[j][1];
				u31j = tmp*ue[j][2];
				u41j = tmp*ue[j][3];
				u51j = tmp*ue[j][4];
				tmp = 1.0/ue[j-1][0];
				u21jm1 = tmp*ue[j-1][1];
				u31jm1 = tmp*ue[j-1][2];
				u41jm1 = tmp*ue[j-1][3];
				u51jm1 = tmp*ue[j-1][4];
				flux[j][1] = ty3*(u21j-u21jm1);
				flux[j][2] = (4.0/3.0)*ty3*(u31j-u31jm1);
				flux[j][3] = ty3*(u41j-u41jm1);
				flux[j][4] = 0.5*(1.0-c1*c5)
					* ty3 * ((u21j*u21j + u31j*u31j +u41j*u41j)
						- (u21jm1*u21jm1+u31jm1*u31jm1+u41jm1*u41jm1))
					+ (1.0/6.0) * ty3 * (u31j*u31j - u31jm1*u31jm1)
					+ c1 * c5 * ty3 * (u51j - u51jm1);
			}
			for(j=1;j<(ny-1);j++) {
				frct[k][j][i][0] += 
					(dy1*ty1*(ue[j-1][0]-2.0*ue[j][0]+ue[j+1][0]));
				frct[k][j][i][1] += 
					(ty3*c3*c4*(flux[j+1][1]-flux[j][1])
					+ dy2*ty1*(ue[j-1][1]-2.0*ue[j][1]+ue[j+1][1]));
				frct[k][j][i][2] +=
					(ty3*c3*c4*(flux[j+1][2]-flux[j][2])
					+ dy3*ty1*(ue[j-1][2]-2.0*ue[j][2]+ue[j+1][2]));
				frct[k][j][i][3] +=
					(ty3*c3*c4*(flux[j+1][3]-flux[j][3])
					+ dy4*ty1*(ue[j-1][3]-2.0*ue[j][3]+ue[j+1][3]));
				frct[k][j][i][4] +=
					(ty3*c3*c4*(flux[j+1][4]-flux[j][4])
					+ dy5*ty1*(ue[j-1][4]-2.0*ue[j][4]+ue[j+1][4]));
			}
			for(m=0;m<5;m++) {
				frct[k][1][i][m] -=
					(dsspm * (5.0*ue[1][m]-4.0*ue[2][m]+ue[3][m]));
				frct[k][2][i][m] -=
					(dsspm*(-4.0*ue[1][m]+6.0*ue[2][m]-4.0*ue[3][m]+ue[4][m]));
			}
			for(j=3;j<(ny-3);j++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -=
						(dsspm*(ue[j-2][m]-4.0*ue[j-1][m]+6.0*ue[j][m]
						-4.0*ue[j+1][m]+ue[j+2][m]));
				}
			}
			for(m=0;m<5;m++) {
				frct[k][ny-3][i][m] -=
					(dsspm*(ue[ny-5][m]-4.0*ue[ny-4][m]+6.0*ue[ny-3][m]-
					4.0*ue[ny-2][m]));
				frct[k][ny-2][i][m] -=
					(dsspm*(ue[ny-4][m]-4.0*ue[ny-3][m]+5.0*ue[ny-2][m]));
			}
		}
	}
	for(j=1;j<(ny-1);j++) {
		eta = ((double)(j)/(ny-1));
		for(i=1;i<(nx-1);i++) {
			xi = ((double)(i)/(nx-1));
			for(k=0;k<nz;k++) {
				zeta = ((double)(k)/(nz-1));
				for(m=0;m<5;m++) {
					ue[k][m] = ce[0][m]
						+ ce[1][m] * xi
						+ ce[2][m] * eta
						+ ce[3][m] * zeta
						+ ce[4][m] * xi * xi
						+ ce[5][m] * eta * eta
						+ ce[6][m] * zeta * zeta
						+ ce[7][m] * xi * xi * xi
						+ ce[8][m] * eta * eta * eta
						+ ce[9][m] * zeta * zeta * zeta
						+ ce[10][m] * xi * xi * xi * xi
						+ ce[11][m] * eta * eta * eta * eta
						+ ce[12][m] * zeta * zeta * zeta * zeta;
				}
				flux[k][0] = ue[k][3];
				u41 = ue[k][3]/ue[k][0];
				q = 0.5 * ( ue[k][1]*ue[k][1]
						  + ue[k][2]*ue[k][2]
						  + ue[k][3]*ue[k][3])/ue[k][0];
				flux[k][1] = ue[k][1] * u41;
				flux[k][2] = ue[k][2] * u41;
				flux[k][3] = ue[k][3] * u41 +c2*(ue[k][4]-q);
				flux[k][4] = (c1*ue[k][4]-c2*q) * u41;
			}
			for(k=1;k<(nz-1);k++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -= (tz2*(flux[k+1][m]-flux[k-1][m]));
				}
			}
			for(k=1;k<nz;k++) {
				tmp = 1.0/ue[k][0];
				u21k = tmp*ue[k][1];
				u31k = tmp*ue[k][2];
				u41k = tmp*ue[k][3];
				u51k = tmp*ue[k][4];
				tmp = 1.0/ue[k-1][0];
				u21km1 = tmp*ue[k-1][1];
				u31km1 = tmp*ue[k-1][2];
				u41km1 = tmp*ue[k-1][3];
				u51km1 = tmp*ue[k-1][4];
				flux[k][1] = tz3*(u21k-u21km1);
				flux[k][2] = tz3*(u31k-u31km1);
				flux[k][3] = (4.0/3.0)*tz3*(u41k-u41km1);
				flux[k][4] = 0.5*(1.0-c1*c5)
					* tz3 * ((u21k*u21k + u31k*u31k +u41k*u41k)
						- (u21km1*u21km1+u31km1*u31km1+u41km1*u41km1))
					+ (1.0/6.0) * tz3 * (u41k*u41k - u41km1*u41km1)
					+ c1 * c5 * tz3 * (u51k - u51km1);
			}
			for(k=1;k<(nz-1);k++) {
				frct[k][j][i][0] += 
					(dz1*tz1*(ue[k+1][0]-2.0*ue[k][0]+ue[k-1][0]));
				frct[k][j][i][1] += 
					(tz3*c3*c4*(flux[k+1][1]-flux[k][1])
					+ dz2*tz1*(ue[k+1][1]-2.0*ue[k][1]+ue[k-1][1]));
				frct[k][j][i][2] +=
					(tz3*c3*c4*(flux[k+1][2]-flux[k][2])
					+ dz3*tz1*(ue[k+1][2]-2.0*ue[k][2]+ue[k-1][2]));
				frct[k][j][i][3] +=
					(tz3*c3*c4*(flux[k+1][3]-flux[k][3])
					+ dz4*tz1*(ue[k+1][3]-2.0*ue[k][3]+ue[k-1][3]));
				frct[k][j][i][4] +=
					(tz3*c3*c4*(flux[k+1][4]-flux[k][4])
					+ dz5*tz1*(ue[k+1][4]-2.0*ue[k][4]+ue[k-1][4]));
			}
			for(m=0;m<5;m++) {
				frct[1][j][i][m] -=
					(dsspm * (5.0*ue[1][m]-4.0*ue[2][m]+ue[3][m]));
				frct[2][j][i][m] -=
					(dsspm*(-4.0*ue[1][m]+6.0*ue[2][m]-4.0*ue[3][m]+ue[4][m]));
			}
			for(k=3;k<(nz-3);k++) {
				for(m=0;m<5;m++) {
					frct[k][j][i][m] -=
						(dsspm*(ue[k-2][m]-4.0*ue[k-1][m]+6.0*ue[k][m]
						-4.0*ue[k+1][m]+ue[k+2][m]));
				}
			}
			for(m=0;m<5;m++) {
				frct[nz-3][j][i][m] -=
					(dsspm*(ue[nz-5][m]-4.0*ue[nz-4][m]+6.0*ue[nz-3][m]-
					4.0*ue[nz-2][m]));
				frct[nz-2][j][i][m] -=
					(dsspm*(ue[nz-4][m]-4.0*ue[nz-3][m]+5.0*ue[nz-2][m]));
			}
		}
	}
}

