#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>

#include "applu.h"

static jacu_a();
static jacu_b();
static jacu_c();

jacu()
{
	jacu_a();
	jacu_b();
	jacu_c();
}

jacu_a()
{
	double r43, c1345, c34;
	int i,j,k;
	double tmp1, tmp2, tmp3;

	r43 = (4.0/3.0);
	c1345 = c1 * c3 * c4 * c5;
	c34 = c3 * c4;

	for(k=1;k<(nz-1);k++) {
		for(j=1;j<(ny-1);j++) {
			for(i=1;i<(nx-1);i++) {

/* form the first block sub-diagonal */
				tmp1 = 1.0/u[k][j][i+1][0];
				tmp2 = tmp1 * tmp1;
				tmp3 = tmp1 * tmp2;

				a[k][j][i][0][0] =  -dt*tx1*dx1;
				a[k][j][i][1][0] =  dt*tx2;
				a[k][j][i][2][0] =  0.0;
				a[k][j][i][3][0] =  0.0;
				a[k][j][i][4][0] =  0.0;

				a[k][j][i][0][1] =  dt*tx2
					*(-(u[k][j][i+1][1]*tmp1)*(u[k][j][i+1][1]*tmp1)
					+c2*0.5*(u[k][j][i+1][1]*u[k][j][i+1][1]
							+u[k][j][i+1][2]*u[k][j][i+1][2]
							+u[k][j][i+1][3]*u[k][j][i+1][3])*tmp2)
					-dt*tx1*(-r43*c34*tmp2*u[k][j][i+1][1]);
				a[k][j][i][1][1] = dt*tx2
					*((2.0-c2)*(u[k][j][i+1][1]*tmp1))
					-dt*tx1*(r43*c34*tmp1)
					-dt*tx1*dx2;
				a[k][j][i][2][1] =  dt*tx2
					*(-c2*(u[k][j][i+1][2]*tmp1));
				a[k][j][i][3][1] = dt*tx2
					*(-c2*(u[k][j][i+1][3]*tmp1));
				a[k][j][i][4][1] = dt*tx2*c2;

				a[k][j][i][0][2] = dt*tx2
					*(-(u[k][j][i+1][1]*u[k][j][i+1][2])*tmp2)
					-dt*tx1*(-c34*tmp2*u[k][j][i+1][2]);
				a[k][j][i][1][2] = dt*tx2*(u[k][j][i+1][2]*tmp1);
				a[k][j][i][2][2] = dt*tx2*(u[k][j][i+1][1]*tmp1)
					-dt*tx1*(c34*tmp1)
					-dt*tx1*dx3;
				a[k][j][i][3][2] = 0.0;
				a[k][j][i][4][2] = 0.0;

				a[k][j][i][0][3] = dt*tx2
					*(-(u[k][j][i+1][1]*u[k][j][i+1][3])*tmp2)
					-dt*tx1*(-c34*tmp2*u[k][j][i+1][3]);
				a[k][j][i][1][3] = dt*tx2*(u[k][j][i+1][3]*tmp1);
				a[k][j][i][2][3] = 0.0;
				a[k][j][i][3][3] = dt*tx2*(u[k][j][i+1][1]*tmp1)
					-dt*tx1*(c34*tmp1)
					-dt*tx1*dx4;
				a[k][j][i][4][3] = 0.0;

				a[k][j][i][0][4] =  dt*tx2
					*((c2*(u[k][j][i+1][1]*u[k][j][i+1][1]
						  +u[k][j][i+1][2]*u[k][j][i+1][2]
						  +u[k][j][i+1][3]*u[k][j][i+1][3])*tmp2
					  -c1*(u[k][j][i+1][4]*tmp1))
					*(u[k][j][i+1][1]*tmp1))
					-dt*tx1
					*(-(r43*c34-c1345)*tmp3*(u[k][j][i+1][1]*u[k][j][i+1][1])
					  -(c34-c1345)*tmp3*(u[k][j][i+1][2]*u[k][j][i+1][2])
					  -(c34-c1345)*tmp3*(u[k][j][i+1][3]*u[k][j][i+1][3])
					  -c1345*tmp2*u[k][j][i+1][4]);
				a[k][j][i][1][4] = dt*tx2
					*(c1*(u[k][j][i+1][4]*tmp1)
					 -0.5*c2
					 *((3.0*u[k][j][i+1][1]*u[k][j][i+1][1]
					   +u[k][j][i+1][2]*u[k][j][i+1][2]
					   +u[k][j][i+1][3]*u[k][j][i+1][3])*tmp2))
					-dt*tx1
					*(r43*c34-c1345)*tmp2*u[k][j][i+1][1];
				a[k][j][i][2][4] = dt*tx2
					*(-c2*(u[k][j][i+1][2]*u[k][j][i+1][1])*tmp2)
					-dt*tx1
					*(c34-c1345)*tmp2*u[k][j][i+1][2];
				a[k][j][i][3][4] = dt*tx2
					*(-c2*(u[k][j][i+1][3]*u[k][j][i+1][1])*tmp2)
					-dt*tx1
					*(c34-c1345)*tmp2*u[k][j][i+1][3];
				a[k][j][i][4][4] = dt*tx2
					*(c1*(u[k][j][i+1][1]*tmp1))
					-dt*tx1*c1345*tmp1
					-dt*tx1*dx5;


			}
		}
	}
}

jacu_b()
{
	double r43, c1345, c34;
	int i,j,k;
	double tmp1, tmp2, tmp3;

	r43 = (4.0/3.0);
	c1345 = c1 * c3 * c4 * c5;
	c34 = c3 * c4;

	for(k=1;k<(nz-1);k++) {
		for(j=1;j<(ny-1);j++) {
			for(i=1;i<(nx-1);i++) {

/* form the second block sub-diagonal */
				
				tmp1 = 1.0 / u[k][j+1][i][0];
				tmp2 = tmp1 * tmp1;
				tmp3 = tmp1 * tmp2;

				b[k][j][i][0][0] = -dt*ty1*dy1;
				b[k][j][i][1][0] = 0.0;
				b[k][j][i][2][0] = dt*ty2;
				b[k][j][i][3][0] = 0.0;
				b[k][j][i][4][0] = 0.0;

				b[k][j][i][0][1] = dt*ty2
					*(-(u[k][j+1][i][1]*u[k][j+1][i][2])*tmp2)
					-dt*ty1*(-c34*tmp2*u[k][j+1][i][1]);
				b[k][j][i][1][1] = dt*ty2*(u[k][j+1][i][2]*tmp1)
					-dt*ty1*(c34*tmp1)
					-dt*ty1*dy2;
				b[k][j][i][2][1] = dt*ty2*(u[k][j+1][i][1]*tmp1);
				b[k][j][i][3][1] = 0.0;
				b[k][j][i][4][1] = 0.0;

				b[k][j][i][0][2] = dt*ty2
					*(-(u[k][j+1][i][2]*tmp1)*(u[k][j+1][i][2]*tmp1)
					+0.5*c2*((u[k][j+1][i][1]*u[k][j+1][i][1]
							 +u[k][j+1][i][2]*u[k][j+1][i][2]
							 +u[k][j+1][i][3]*u[k][j+1][i][3])
							*tmp2))
					-dt*ty1*(-r43*c34*tmp2*u[k][j+1][i][2]);
				b[k][j][i][1][2] = dt*ty2
					*(-c2*(u[k][j+1][i][1]*tmp1));
				b[k][j][i][2][2] = dt*ty2*((2.0-c2)
					*(u[k][j+1][i][2]*tmp1))
					-dt*ty1*(r43*c34*tmp1)
					-dt*ty1*dy3;
				b[k][j][i][3][2] = dt*ty2
					*(-c2*(u[k][j+1][i][3]*tmp1));
				b[k][j][i][4][2] = dt*ty2*c2;

				b[k][j][i][0][3] = dt*ty2
					*(-(u[k][j+1][i][2]*u[k][j+1][i][3])*tmp2)
					-dt*ty1*(-c34*tmp2*u[k][j+1][i][3]);
				b[k][j][i][1][3] = 0.0;
				b[k][j][i][2][3] = dt*ty2*(u[k][j+1][i][3]*tmp1);
				b[k][j][i][3][3] = dt*ty2*(u[k][j+1][i][2]*tmp1)
					-dt*ty1*(c34*tmp1)
					-dt*ty1*dy4;
				b[k][j][i][4][3] = 0.0;

				b[k][j][i][0][4] = dt*ty2
					*((c2*(u[k][j+1][i][1]*u[k][j+1][i][1]
						  +u[k][j+1][i][2]*u[k][j+1][i][2]
						  +u[k][j+1][i][3]*u[k][j+1][i][3])*tmp2
					  -c1*(u[k][j+1][i][4]*tmp1))
					*(u[k][j+1][i][2]*tmp1))
					-dt*ty1
					*(-(c34-c1345)*tmp3*(u[k][j+1][i][1]*u[k][j+1][i][1])
					  -(r43*c34-c1345)*tmp3*(u[k][j+1][i][2]*u[k][j+1][i][2])
					  -(c34-c1345)*tmp3*(u[k][j+1][i][3]*u[k][j+1][i][3])
					  -c1345*tmp2*u[k][j+1][i][4]);
				b[k][j][i][1][4] = dt*ty2
					*(-c2*(u[k][j+1][i][1]*u[k][j+1][i][2])*tmp2)
					-dt*ty1
					*(c34-c1345)*tmp2*u[k][j+1][i][1];
				b[k][j][i][2][4] = dt*ty2
					*(c1*(u[k][j+1][i][4]*tmp1)
					-0.5*c2
					*((u[k][j+1][i][1]*u[k][j+1][i][1]
					  +3.0*u[k][j+1][i][2]*u[k][j+1][i][2]
					  +u[k][j+1][i][3]*u[k][j+1][i][3])*tmp2))
					-dt*ty1
					*(r43*c34-c1345)*tmp2*u[k][j+1][i][2];
				b[k][j][i][3][4] = dt*ty2
					*(-c2*(u[k][j+1][i][2]*u[k][j+1][i][3])*tmp2)
					-dt*ty1*(c34-c1345)*tmp2*u[k][j+1][i][3];
				b[k][j][i][4][4] = dt*ty2
					*(c1*(u[k][j+1][i][2]*tmp1))
					-dt*ty1*c1345*tmp1
					-dt*ty1*dy5;

			}
		}
	}
}

jacu_c()
{
	double r43, c1345, c34;
	int i,j,k;
	double tmp1, tmp2, tmp3;

	r43 = (4.0/3.0);
	c1345 = c1 * c3 * c4 * c5;
	c34 = c3 * c4;

	for(k=1;k<(nz-1);k++) {
		for(j=1;j<(ny-1);j++) {
			for(i=1;i<(nx-1);i++) {

/*form the third block subdiagonal*/
				tmp1 = 1.0 / u[k+1][j][i][0];
				tmp2 = tmp1 * tmp1;
				tmp3 = tmp1 * tmp2;

				c[k][j][i][0][0] = -dt * tz1 * dz1;
				c[k][j][i][1][0] = 0.0;
				c[k][j][i][2][0] = 0.0;
				c[k][j][i][3][0] = dt * tz2;
				c[k][j][i][4][0] = 0.0;

				c[k][j][i][0][1] = dt * tz2 *
					( - (u[k+1][j][i][1]*u[k+1][j][i][3])*tmp2)
					- dt * tz1 * (-c34 * tmp2 *u[k+1][j][i][1]);
				c[k][j][i][1][1] = dt *tz2 * (u[k+1][j][i][3]*tmp1)
					-dt * tz1 * c34 * tmp1
					-dt * tz1 * dz2;
				c[k][j][i][2][1] = 0.0;
				c[k][j][i][3][1] = dt * tz2 * (u[k+1][j][i][1]*tmp1);
				c[k][j][i][4][1] = 0.0;

				c[k][j][i][0][2] = dt * tz2 *
					( - (u[k+1][j][i][2]*u[k+1][j][i][3])*tmp2)
					- dt * tz1 * (-c34 * tmp2 *u[k+1][j][i][2]);
				c[k][j][i][1][2] = 0.0;
				c[k][j][i][2][2] = dt *tz2 * u[k+1][j][i][3]*tmp1
					-dt * tz1 * c34 * tmp1
					-dt * tz1 * dz3;
				c[k][j][i][3][2] = dt * tz2 * (u[k+1][j][i][2]*tmp1);
				c[k][j][i][4][2] = 0.0;

				c[k][j][i][0][3] = dt * tz2 *
					(-(u[k+1][j][i][3]*tmp1)*(u[k+1][j][i][3]*tmp1)
					 + 0.5 * c2 *
					 ((u[k+1][j][i][1]*u[k+1][j][i][1]
					  +u[k+1][j][i][2]*u[k+1][j][i][2]
					  +u[k+1][j][i][3]*u[k+1][j][i][3])*tmp2))
					- dt * tz1 * (-r43*c34*tmp2*u[k+1][j][i][3]) ;
				c[k][j][i][1][3] = dt * tz2 *
					(-c2 * (u[k+1][j][i][1] * tmp1));
				c[k][j][i][2][3] = dt * tz2 *
					(-c2 * (u[k+1][j][i][2] * tmp1));
				c[k][j][i][3][3] = dt * tz2 * (2.0 - c2) *
					(u[k+1][j][i][3]*tmp1)
					- dt * tz1 * (r43 * c34 * tmp1)
					- dt * tz1 * dz4;
				c[k][j][i][4][3] = dt * tz2 * c2;

				c[k][j][i][0][4] = dt * tz2 *
					((c2*(u[k+1][j][i][1]*u[k+1][j][i][1]
						+u[k+1][j][i][2]*u[k+1][j][i][2]
						+u[k+1][j][i][3]*u[k+1][j][i][3])*tmp2
					-c1 * (u[k+1][j][i][4]*tmp1))
						* (u[k+1][j][i][3]*tmp1))
					-dt * tz1
					*( - (c34-c1345)*tmp3*(u[k+1][j][i][1]*u[k+1][j][i][1])
					   - (c34-c1345)*tmp3*(u[k+1][j][i][2]*u[k+1][j][i][2])
					   - (r43*c34-c1345)*tmp3*(u[k+1][j][i][3]*u[k+1][j][i][3])
					   - c1345*tmp2*u[k+1][j][i][4]);
				c[k][j][i][1][4] = dt * tz2
					*(-c2*(u[k+1][j][i][1]*u[k+1][j][i][3])*tmp2)
					-dt*tz1*(c34-c1345)*tmp2*u[k+1][j][i][1];
				c[k][j][i][2][4] = dt*tz2
					*(-c2*(u[k+1][j][i][2]*u[k+1][j][i][3])*tmp2)
					-dt*tz1*(c34-c1345)*tmp2*u[k+1][j][i][2];
				c[k][j][i][3][4] = dt*tz2
					*(c1*(u[k+1][j][i][4]*tmp1)
					-0.5*c2
					*((u[k+1][j][i][1]*u[k+1][j][i][1]
					  +u[k+1][j][i][2]*u[k+1][j][i][2]
					  +3.0*u[k+1][j][i][3]*u[k+1][j][i][3])*tmp2))
					-dt*tz1*(r43*c34-c1345)*tmp2*u[k+1][j][i][3];
				c[k][j][i][4][4] = dt*tz2
					*(c1*(u[k+1][j][i][3]*tmp1))
					-dt*tz1*c1345*tmp1
					-dt*tz1*dz5;

			}
		}
	}
}
